## labplot 2.12.1+p24.04+vstable+git20250926.1109

=== debian/changelog ===
labplot (2.12.1+p24.04+vstable+git20250926.1109-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Fri, 26 Sep 2025 11:10:13 +0000

labplot (2.12.1-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Sat, 16 Aug 2025 06:52:10 +0000

labplot (2.12.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Sun, 27 Apr 2025 06:52:10 +0000
