## labplot 2.12.1+p24.04+vstable+git20251020.0042

=== debian/changelog ===
labplot (2.12.1+p24.04+vstable+git20251020.0042-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Mon, 20 Oct 2025 00:42:37 +0000
