=== debian/changelog ===
labplot (2.12.1+p24.04+vstable+git20251021.0345-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Tue, 21 Oct 2025 03:45:54 +0000
