=== debian/control ===
Source: labplot
Section: math
Priority: optional
Uploaders: Pino Toscano <pino@debian.org>
Build-Depends: bison,
               cmake (>= 3.17.0~),
               dbc-parser-cpp-dev,
               debhelper-compat (= 13),
               extra-cmake-modules,
               gettext,
               kf6-karchive-dev,
               kf6-kcompletion-dev,
               kf6-kconfig-dev,
               kf6-kconfigwidgets-dev,
               kf6-kcoreaddons-dev,
               kf6-kcrash-dev,
               kf6-kdoctools-dev,
               kf6-ki18n-dev,
               kf6-kiconthemes-dev,
               kf6-kio-dev,
               kf6-knewstuff-dev,
               kf6-kparts-dev,
               kf6-kservice-dev,
               kf6-ktextwidgets-dev,
               kf6-kuserfeedback-dev,
               kf6-kwidgetsaddons-dev,
               kf6-kxmlgui-dev,
               kf6-purpose-dev,
               kf6-syntax-highlighting-dev,
               libboost-dev,
               libcantor-dev [amd64 arm64 armhf i386 mips64el],
               libcerf-dev,
               libcfitsio-dev,
               libeigen3-dev,
               libfftw3-dev,
               libgsl-dev,
               libhdf5-dev,
               libixion-dev,
               liblz4-dev,
               libmarkdown2-dev,
               libmatio-dev,
               libnetcdf-dev,
               liborcus-dev,
               liborigin-dev,
               libpoppler-qt6-dev,
               libqt6-advanced-docking-system-dev,
               libqt6qxlsx-dev,
               libreadstat-dev,
               libspectre-dev,
               libvector-blf-dev,
               locales-all <!nocheck>,
               pkg-kde-tools-neon,
               pkgconf,
               qt6-base-dev,
               qt6-mqtt-dev,
               qt6-serialport-dev,
               xauth <!nocheck>,
               xvfb <!nocheck>,
               zlib1g-dev
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://labplot.kde.org/
Vcs-Git: https://invent.kde.org/neon/extras/labplot.git
Vcs-Browser: https://invent.kde.org/neon/extras/labplot
Maintainer: Neon CI <neon@kde.org>

Package: labplot
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: labplot-data (<< 2.12.0)
Replaces: labplot-data (<< 2.12.0)
Description: interactive graphing and analysis of scientific data
 LabPlot provides an easy way to create, manage and edit plots.  It allows you
 to produce plots based on data from a spreadsheet or on data imported from
 external files.  Plots can be exported to several pixmap and vector graphic
 formats.
 .
 Features include:
  - project-based management of data
  - project explorer for management and organization of created objects in
    different folders and sub-folders
  - spreadsheet with basic functionality for manual data entry or for
    generation of uniform and non-uniform random numbers
  - import of external ASCII data into the project for further editing and
    visualization
  - export of spreadsheet to an ASCII file
  - worksheet as the main parent object for plots, labels, etc; supports
    different layouts and zooming functions
  - export of worksheet to different formats (PDF, EPS, PNG, and SVG)
  - great variety of editing capabilities for properties of worksheet and its
    objects
  - cartesian plots, created either from imported or manually created data
    sets or via mathematical equation
  - definition of mathematical formulas is supported by syntax highlighting
    and completion and by the list of thematically grouped mathematical and
    physical constants and functions
  - analysis of plotted data is supported by many zooming and navigation
    features
  - linear and non-linear fits to data, several fit-models are predefined and
    custom models with arbitrary number of parameters can be provided

Package: labplot-dev
Architecture: any
Depends: labplot (= ${source:Version}), ${misc:Depends}
Description: dev files for labplot
 LabPlot provides an easy way to create, manage and edit plots.  It allows you
 to produce plots based on data from a spreadsheet or on data imported from
 external files.  Plots can be exported to several pixmap and vector graphic
 formats.
 .
 This contains the dev files for labplot.
