=== debian/changelog ===
labplot (2.12.1+p24.04+vstable+git20251030.0020-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Thu, 30 Oct 2025 00:20:17 +0000
