## labplot 2.12.1+p24.04+vstable+git20251031.0255

=== debian/changelog ===
labplot (2.12.1+p24.04+vstable+git20251031.0255-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Fri, 31 Oct 2025 02:55:46 +0000
