## labplot 2.12.1+p24.04+vstable+git20251101.0211

=== debian/changelog ===
labplot (2.12.1+p24.04+vstable+git20251101.0211-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sat, 01 Nov 2025 02:11:41 +0000
