## labplot 2.12.1+p24.04+vstable+git20251111.0233

=== debian/changelog ===
labplot (2.12.1+p24.04+vstable+git20251111.0233-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Tue, 11 Nov 2025 02:33:55 +0000
