## labplot 2.12.1+p24.04+vstable+git20251112.0202

=== debian/changelog ===
labplot (2.12.1+p24.04+vstable+git20251112.0202-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 12 Nov 2025 02:02:30 +0000
